//
// String2: extends std::string with some useful things
//

#include <stdarg.h>
#include <string>
using namespace std;

#ifdef WIN32
#  define WIN_UNIX_CDECL __cdecl
#else
#  define WIN_UNIX_CDECL
#endif

class String2 : public std::string
{
public:
	void WIN_UNIX_CDECL Printf(const char *szFormat, ...)
	{
		va_list va;
		va_start(va, szFormat);

		char ach[4096];
		vsprintf(ach, szFormat, va);

		assign(ach);
	}
	void TrimLeft()
	{
		int len = length();
		while (len > 0 && isspace(at(0)))
		{
			erase(0, 1);
			len--;
		}
	}
	void TrimRight()
	{
		int i = length()-1;
		while (i > 0 && isspace(at(i)))
		{
			erase(i, 1);
			i--;
		}
	}
	operator const char *() const	// return pointer to const string
	{
		return c_str();
	}

	// Not sure why the following are necessary; i would think that it would
	//  pick up on these by inheritance, but apparently not.

	String2& operator=(const char *_Ptr)
	{
		return (String2&)(assign(_Ptr));
	}
	char operator[](int _Off) const	// subscript
	{
		return (*(*this + _Off));
	}
};


