//
// TripDub.h
//
// Module for Double-You-Double-You-Double-You support (WWW)
// Ref: http://web.yost.com/Misc/nix-on-www.html
//
// Copyright (c) 2003 Virtual Terrain Project
// Free for all uses, see license.txt for details.
//

#ifndef VTDATA_TRIPDUB_H
#define VTDATA_TRIPDUB_H

#include "String2.h"

#include <string>
using namespace std;

typedef struct _HTRequest HTRequest;
typedef struct _HTAnchor	HTAnchor;

class ReqContext
{
public:
	ReqContext();
	~ReqContext();

	void AddHeader(const char *token, const char *value);
	void GetURL(const char *url, String2 &str);
	void DoQuery(String2 &str, int redirects = 0);

	/// Set level of logging output: 0 (none) 1 (some) 2 (lots)
	void SetVerbosity(int i) { m_iVerbosity = i; }

	HTRequest *	m_request;
	HTAnchor *	m_anchor;
	char *		m_cwd;				  /* Current dir URL */

	static bool s_bFirst;
	int m_iVerbosity;
	void InitializeLibrary();
};

void AddCookie(const char *name, const char *value);

#endif // VTDATA_TRIPDUB_H

